#include <stdio.h>
#include <spu_intrinsics.h>
#include <spu_mfcio.h>
#include <tnw_spu.h>
#include <torus_spu.h>

#include "commands.h"

#define READ_MAIL() spu_readch(SPU_RdInMbox)
#define WRITE_MAIL(a) spu_writech(SPU_WrOutMbox,(a))


#define WAIT_DMA(tag)    \
spu_writech(MFC_WrTagMask, (1 << tag)); \
(void)spu_mfcstat(MFC_TAG_UPDATE_ALL);


unsigned int recv_buf0[4096] __attribute__((aligned(128)));
unsigned int test_buf0[4096] __attribute__((aligned(128)));

tnw_rx_t rx;

#define MSGSIZE (1024)


int command_loop();

void fill_message(unsigned int *p, uint n, uint link, uint channel) {

  uint i;  
 
  for (i=0;i<n/4;i+=4) {
    p[i]=link;
    p[i+1]=channel;
    p[i+2]=i+2;
    p[i+3]=i+3;
    
  }
}


void recv_send_sb() {

  
  uint ch;
  uint nidx;
  uint iter = 128;
  uint dma_tag;
  
  tnw_rx_t *rx_ptr;

  
  
  ch = READ_MAIL();
  
  printf("recv... on lnk %d ch %d spu physical id = %d\n", __torus_lnk[TORUS_YM], ch, 
	 tnw_get_spe_phys_id());
  
  dma_tag = mfc_tag_reserve();

  torus_config_recv(TORUS_YM, ch, 0, &rx); 
  
  /* prepare the message */
  fill_message(test_buf0, MSGSIZE, __torus_lnk[TORUS_YM], ch);
  
  nidx = 0;

  while(iter) {
  
    /* credit with ctag nidx   */
    torus_recv(&rx, (uint)recv_buf0, MSGSIZE, nidx);
  
    /* wait the previous send */
    torus_wait_send(dma_tag);
    
            
    torus_send(TORUS_YP, ch, test_buf0, 0, MSGSIZE, dma_tag);
    
    /* wait for the notify to arrive, rx handler rx, ctag  nidx */
    
    torus_wait_recv(&rx, nidx);
    
    printf("exit wait nidx = %d\n", nidx);
    
    nidx++;
    nidx = nidx%16;
    iter--;
  }
  
  mfc_tag_release(dma_tag);
  
  printf("ciaooo\n");
}

int main(unsigned long long id, unsigned long long argp, 
	 unsigned long long envp) {
  
  
  
  torus_init(id);
  
  command_loop();
  
  torus_finalize();
	
  return 0;
}


int command_loop() {
  
  uint cmd;
    
  for(;;) {

    cmd=READ_MAIL();
    
    switch (cmd) {

    case SPU_CMD_EXIT:
      return (0);
      break;
             
    case SPU_CMD_RECV:
      recv_send_sb();
      break;

    case SPU_CMD_SEND:
      //send();
      break;
      
    default:
      break;
      
    }
    
  }
  return 1;
}

