#ifndef TORUS_H
#define TORUS_H


typedef enum {
  TORUS_XP, 
  TORUS_XM, 
  TORUS_YP, 
  TORUS_YM, 
  TORUS_ZP, 
  TORUS_ZM,

} torus_direction;


typedef enum {
  
  TORUS_MAP_X,
  TORUS_MAP_Y,
  TORUS_MAP_Z,

} torus_map;


#define torus_init(id) \
  tnw_init((id))

#define torus_finalize() \
  tnw_finalize()

/***
void torus_send(torus_direction direction, unsigned int channel, void *txbuf, 
unsigned int size, unsigned int dmatag);
***/
#define torus_send(direction, channel, txbuf, offs, size, dmatag)	\
  tnw_put(__torus_lnk[(direction)], (channel), (txbuf), (offs), (size), (dmatag));

/***
unsigned int torus_test_send(unsigned int dmatag); 
***/
#define torus_test_send(dmatag) \
  tnw_test_put((dmatag))

/***
void torus_wait_send(unsigned int dmatag);
***/
#define torus_wait_send(dmatag) \
  tnw_wait_put((dmatag))

/*
void torus_config_recv(torus_direction direction, unsigned int channel, unsigned int page_raddr, tnw_rx_t *rx); 
*/

#define torus_config_recv(direction, channel, page_raddr, rx) \
  tnw_init_rx((rx), __torus_lnk[(direction)], (channel));	\
  tnw_credit_base(__torus_lnk[(direction)], (channel), (page_raddr))

#define torus_recv(rx, offs, size, ctag) \
  tnw_credit((rx), (unsigned int)(offs), (size), (ctag));

#define torus_wait_recv(rx, ctag) \
  tnw_wait_notify((rx), (ctag))

#define torus_test_recv(rx, ctag) \
  tnw_test_notify((rx), (ctag))

extern unsigned int __torus_lnk[6];
#endif
